﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Collections.ObjectModel;
using System.Drawing.Printing;


namespace Ticket2910Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"C:\Program Files\ThinkGeo\Map Suite Desktop Full Edition 4.5\Samples\SampleData\Data\Countries02.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new QualityFamilyAreaStyle(new GeoPen(GeoColor.StandardColors.Gray), GeoColor.SimpleColors.PaleBlue, 15);
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay worldOverlay = new LayerOverlay();
            worldOverlay.Layers.Add("WorldLayer", worldLayer);
            winformsMap1.Overlays.Add("StaticOverlay", worldOverlay);

            winformsMap1.ZoomLevelSnapping = ZoomLevelSnappingMode.Default;
            winformsMap1.CurrentExtent = new RectangleShape(-143.4, 109.3, 116.7, -76.3);
            winformsMap1.Refresh();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PrinterGeoCanvas printerGeoCanvas = new PrinterGeoCanvas();

            Collection<SimpleCandidate> labelsInLayers = new Collection<SimpleCandidate>();
            PrintDocument document = new PrintDocument();
            printerGeoCanvas.DrawingArea = new Rectangle(0, 0, winformsMap1.Width, winformsMap1.Height);
            printerGeoCanvas.BeginDrawing(document, winformsMap1.CurrentExtent, winformsMap1.MapUnit);
            foreach (Overlay ovelray in winformsMap1.Overlays)
            {
                if (ovelray is LayerOverlay)
                {
                    foreach(Layer layer in ((LayerOverlay)ovelray).Layers)
                    {
                        layer.Open();
                        layer.Draw(printerGeoCanvas, labelsInLayers);
                        layer.Close();
                        printerGeoCanvas.Flush();
                    }
                }
            }
            printerGeoCanvas.EndDrawing();
        }
    }
}
